package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.TrailerUser;
import de.humance.eco.profile.model.TrailerUserModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the TrailerUser service. Represents a row in the &quot;Profile_TrailerUser&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.TrailerUserModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link TrailerUserImpl}.
 * </p>
 *
 * @author Humance
 * @see TrailerUserImpl
 * @see de.humance.eco.profile.model.TrailerUser
 * @see de.humance.eco.profile.model.TrailerUserModel
 * @generated
 */
public class TrailerUserModelImpl extends BaseModelImpl<TrailerUser>
    implements TrailerUserModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a trailer user model instance should use the {@link de.humance.eco.profile.model.TrailerUser} interface instead.
     */
    public static final String TABLE_NAME = "Profile_TrailerUser";
    public static final Object[][] TABLE_COLUMNS = {
            { "trailerUserId", Types.BIGINT },
            { "userId", Types.BIGINT },
            { "trailerId", Types.BIGINT }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_TrailerUser (trailerUserId LONG not null primary key,userId LONG,trailerId LONG)";
    public static final String TABLE_SQL_DROP = "drop table Profile_TrailerUser";
    public static final String ORDER_BY_JPQL = " ORDER BY trailerUser.userId ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_TrailerUser.userId ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.TrailerUser"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.TrailerUser"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.TrailerUser"),
            true);
    public static long TRAILERID_COLUMN_BITMASK = 1L;
    public static long USERID_COLUMN_BITMASK = 2L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.TrailerUser"));
    private static ClassLoader _classLoader = TrailerUser.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            TrailerUser.class
        };
    private long _trailerUserId;
    private String _trailerUserUuid;
    private long _userId;
    private String _userUuid;
    private long _originalUserId;
    private boolean _setOriginalUserId;
    private long _trailerId;
    private long _originalTrailerId;
    private boolean _setOriginalTrailerId;
    private long _columnBitmask;
    private TrailerUser _escapedModel;

    public TrailerUserModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _trailerUserId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setTrailerUserId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _trailerUserId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return TrailerUser.class;
    }

    @Override
    public String getModelClassName() {
        return TrailerUser.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("trailerUserId", getTrailerUserId());
        attributes.put("userId", getUserId());
        attributes.put("trailerId", getTrailerId());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long trailerUserId = (Long) attributes.get("trailerUserId");

        if (trailerUserId != null) {
            setTrailerUserId(trailerUserId);
        }

        Long userId = (Long) attributes.get("userId");

        if (userId != null) {
            setUserId(userId);
        }

        Long trailerId = (Long) attributes.get("trailerId");

        if (trailerId != null) {
            setTrailerId(trailerId);
        }
    }

    @Override
    public long getTrailerUserId() {
        return _trailerUserId;
    }

    @Override
    public void setTrailerUserId(long trailerUserId) {
        _trailerUserId = trailerUserId;
    }

    @Override
    public String getTrailerUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getTrailerUserId(), "uuid",
            _trailerUserUuid);
    }

    @Override
    public void setTrailerUserUuid(String trailerUserUuid) {
        _trailerUserUuid = trailerUserUuid;
    }

    @Override
    public long getUserId() {
        return _userId;
    }

    @Override
    public void setUserId(long userId) {
        _columnBitmask = -1L;

        if (!_setOriginalUserId) {
            _setOriginalUserId = true;

            _originalUserId = _userId;
        }

        _userId = userId;
    }

    @Override
    public String getUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
    }

    @Override
    public void setUserUuid(String userUuid) {
        _userUuid = userUuid;
    }

    public long getOriginalUserId() {
        return _originalUserId;
    }

    @Override
    public long getTrailerId() {
        return _trailerId;
    }

    @Override
    public void setTrailerId(long trailerId) {
        _columnBitmask |= TRAILERID_COLUMN_BITMASK;

        if (!_setOriginalTrailerId) {
            _setOriginalTrailerId = true;

            _originalTrailerId = _trailerId;
        }

        _trailerId = trailerId;
    }

    public long getOriginalTrailerId() {
        return _originalTrailerId;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            TrailerUser.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public TrailerUser toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (TrailerUser) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        TrailerUserImpl trailerUserImpl = new TrailerUserImpl();

        trailerUserImpl.setTrailerUserId(getTrailerUserId());
        trailerUserImpl.setUserId(getUserId());
        trailerUserImpl.setTrailerId(getTrailerId());

        trailerUserImpl.resetOriginalValues();

        return trailerUserImpl;
    }

    @Override
    public int compareTo(TrailerUser trailerUser) {
        int value = 0;

        if (getUserId() < trailerUser.getUserId()) {
            value = -1;
        } else if (getUserId() > trailerUser.getUserId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof TrailerUser)) {
            return false;
        }

        TrailerUser trailerUser = (TrailerUser) obj;

        long primaryKey = trailerUser.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        TrailerUserModelImpl trailerUserModelImpl = this;

        trailerUserModelImpl._originalUserId = trailerUserModelImpl._userId;

        trailerUserModelImpl._setOriginalUserId = false;

        trailerUserModelImpl._originalTrailerId = trailerUserModelImpl._trailerId;

        trailerUserModelImpl._setOriginalTrailerId = false;

        trailerUserModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<TrailerUser> toCacheModel() {
        TrailerUserCacheModel trailerUserCacheModel = new TrailerUserCacheModel();

        trailerUserCacheModel.trailerUserId = getTrailerUserId();

        trailerUserCacheModel.userId = getUserId();

        trailerUserCacheModel.trailerId = getTrailerId();

        return trailerUserCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(7);

        sb.append("{trailerUserId=");
        sb.append(getTrailerUserId());
        sb.append(", userId=");
        sb.append(getUserId());
        sb.append(", trailerId=");
        sb.append(getTrailerId());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(13);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.TrailerUser");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>trailerUserId</column-name><column-value><![CDATA[");
        sb.append(getTrailerUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>userId</column-name><column-value><![CDATA[");
        sb.append(getUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>trailerId</column-name><column-value><![CDATA[");
        sb.append(getTrailerId());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
